package cn.com.ty.lift.push.websocket.config;

import cn.com.ty.lift.common.constants.ApiConstants;
import cn.com.ty.lift.common.constants.WebSocketConstants;
import cn.com.ty.lift.common.model.TimeyUser;
import org.springframework.http.server.ServerHttpRequest;
import org.springframework.http.server.ServerHttpResponse;
import org.springframework.http.server.ServletServerHttpRequest;
import org.springframework.web.socket.WebSocketHandler;
import org.springframework.web.socket.server.HandshakeInterceptor;

import javax.servlet.http.HttpSession;
import java.util.Map;

public class WebSocketInterceptor implements HandshakeInterceptor {

    /**
     * 进入handler之前的拦截
     */
    @Override
    public boolean beforeHandshake(ServerHttpRequest request, ServerHttpResponse response,
                                   WebSocketHandler wsHandler, Map<String, Object> map) {

        if (request instanceof ServletServerHttpRequest) {
            ServletServerHttpRequest serverHttpRequest = (ServletServerHttpRequest) request;
            HttpSession session = serverHttpRequest.getServletRequest().getSession();
            TimeyUser timeyUser = (TimeyUser) session.getAttribute(WebSocketConstants.CURRENT_TIMEY_USER);
            if (timeyUser != null) {
                map.put(ApiConstants.CURRENT_USER_ID, timeyUser.getUserId());
            }
        }
        return true;
    }

    @Override
    public void afterHandshake(ServerHttpRequest request, ServerHttpResponse response, WebSocketHandler wsHandler,
                               Exception exception) {
        ServletServerHttpRequest serverHttpRequest = (ServletServerHttpRequest) request;
        HttpSession session = serverHttpRequest.getServletRequest().getSession();
        TimeyUser timeyUser = (TimeyUser) session.getAttribute(WebSocketConstants.CURRENT_TIMEY_USER);
        if (timeyUser != null) {
            System.out.println("用户" + timeyUser.getUserName() + "连接进入系统");
        } else {
            System.out.println("当前连接为空");
        }
    }

}
